#!/usr/bin/python

# TODO: remove only stale entries during removal phase?

import photos

import os.path

# remove the category entries from flat/*/*/.cats/
# recurse through cat/ and add category entries

# vaguely like this:
# find cat -type l 
# | perl -ne '
#    chop; 
#    /\/([^\/]+)$/ and $f = $1; 
#    s/^cat\///; 
#    s/\/[^\/]*$//; 
#    s/\//./g;  
#    print "$f -> $_\n";
#   '

def addcat(path, name):
  # generate paths and data
  index = path.find("/cat")
  cat = path[index+4:]
  dotcat = cat[1:].replace("/", ".")
  catpath = "%s/%s/.cats" % (path, name)
  contents = "%s" % (cat)
  #print "creating %s/%s (%s)" % (catpath, dotcat, contents)

  # make the .cats/ to put stuff into
  if not os.path.exists(catpath):
    os.mkdir(catpath)

  # make each category file...
  fp = open("%s/%s" % (catpath, dotcat), "w")
  fp.write("%s\n" % (contents))
  fp.close()

def walker(arg, dirname, names):
  #print "dirname: %s" % (dirname)

  for name in names:
    p = "%s/%s/.mimetype" % (dirname, name)
    if os.path.exists(p):
      #print "Checking %s..." % (p)
      fp = open(p, "rb")
      t = fp.readline()
      fp.close()
      t = t.strip()
      if t == "inode/directory":
	#print "skipping dir %s/%s" % (dirname, name)
	pass
      else:
	addcat(dirname, name)
	#names.remove(name)

  # eliminate dotfiles
  i = 0
  while i < len(names):
    name = names[i]
    if name[:1] == ".":
      del names[i]
    else:
      i = i + 1

  # recurse into symlinks
  for name in names:
    p = os.path.join(dirname, name)
    if os.path.islink(p):
      os.path.walk(p, walker, None)

def generate():
  os.path.walk("%s/cat" % (photos.root), walker, None)

def rmwalker(arg, dirname, names):
  #print "dirname: %s" % (dirname)

  if ".data" in names  and  ".cats" not in names:
    print "warning: %s not in any categories" % (dirname)

  i = 0
  while i < len(names):
    name = names[i]
    if name[0] == "."  and name != ".cats":
      del names[i]
    else:
      i = i + 1

  parts = os.path.split(dirname)
  if parts[-1] == ".cats":
    #print "removing %s/*" % (dirname)
    if len(names) == 0:
      print "Warning: %s not in any categories" % (dirname)
    for name in names:
      p = os.path.join(dirname, name)

      # check for broken backlinks to missing categories
      fp = open(p, "rb")
      point = fp.readline()
      fp.close()
      point = point.strip()
      check_cat = "%s/cat%s" % (photos.root, point)
      #print "checking %s" % (check_cat)
      if not os.path.exists(check_cat):
	print "Warning: category %s used but doesn't exist (%s)" % (point, dirname)

      #print "Removing %s" % (p)
      os.remove(p)

def remove():
  os.path.walk("%s/flat" % (photos.root), rmwalker, None)

def run(args):
  print "Removing category data..."
  remove()
  print "Generating category data..."
  generate()

if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
