#!/usr/bin/python

# TODO:
# - write PNGs with original alpha intact

def process(fore, back, outfile):
  import Image
  import math

  #interpolate = Image.NEAREST
  interpolate = Image.BICUBIC
  angle = 16.5
  angle_r = angle * math.pi / 180.0

  # size of sub-icon area, before rotation
  maxwid = 78
  maxhgt = 47

  fimg = Image.open(fore)
  bimg = Image.open(back)

  mask = Image.new("L", fimg.size, 255)

  x,y = fimg.size

  scale_x = maxwid/float(x)
  scale_y = maxhgt/float(y)
  scale = scale_x
  if scale_y < scale_x: scale = scale_y

  xa = x * math.cos(angle_r)
  xb = y * math.sin(angle_r)
  ya = y * math.cos(angle_r)
  yb = x * math.sin(angle_r)

  #print "parts: %s, %s, %s, %s" % (xa, xb, ya, yb)

  outwid = int(math.ceil(xa + xb))
  outhgt = int(math.ceil(ya + yb))
  #print "out: %sx%s" % (outwid, outhgt)
  
  tmpsize = (outwid, outhgt)

  matrix = [1, 0, 0, 0, 1, 0]
  matrix[2] = (x-outwid)/2
  matrix[5] = (y-outhgt)/2

  out = fimg.transform(tmpsize, Image.AFFINE, matrix, interpolate)
  out = out.rotate(angle, interpolate)

  matrix = [1, 0, 0, 0, 1, 0]
  matrix[2] = (x-out.size[0])/2
  matrix[5] = (y-out.size[1])/2
  mask = mask.transform(out.size, Image.AFFINE, matrix)
  mask = mask.rotate(angle, interpolate)

  tmpsize = (int(out.size[0]*scale), int(out.size[1]*scale))
  out.thumbnail(tmpsize, interpolate)
  mask.thumbnail(tmpsize, interpolate)

  matrix = [1, 0, 0, 0, 1, 0]
  matrix[2] = (tmpsize[0] - bimg.size[0])/2
  matrix[5] = (tmpsize[1] - bimg.size[1])/2
  out = out.transform(bimg.size, Image.AFFINE, matrix, interpolate)
  mask = mask.transform(bimg.size, Image.AFFINE, matrix, interpolate)

  out = Image.composite(out, bimg, mask)

  #out.show()
  out.save(outfile, "PNG")

def run(args):
  process(args[0], "/home/photos/gfx/icons/folder.png", args[1])
  #for f in args:
  #  process(f, "folder.png", "out.png")

if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
