#!/usr/bin/python

import photos

def num_unit(num):
  bytes = num
  unit = "b"
  if bytes > 9999:
    unit = "KiB"
    bytes = bytes / 1024
  if bytes > 9999:
    unit = "MiB"
    bytes = bytes / 1024
  if bytes > 9999:
    unit = "GiB"
    bytes = bytes / 1024
  if bytes > 9999:
    unit = "TiB"
    bytes = bytes / 1024

  return "%s%s" % (bytes, unit)

def run(args):
  try:
    fp = open("%s/.stat.files" % photos.root, "rb")
    files = int(fp.readline())
    fp = open("%s/.stat.entries" % photos.root, "rb")
    entries = int(fp.readline())
    fp = open("%s/.stat.cats" % photos.root, "rb")
    cats = int(fp.readline())
    fp = open("%s/.stat.records" % photos.root, "rb")
    records = int(fp.readline())
    fp = open("%s/.stat.bytes" % photos.root, "rb")
    bytes = int(fp.readline())
    hsize = num_unit(bytes)
  except:
    print "Cannot open stat files.  Generate them first with count.sh"
    return
  
  print "PhotoFS stats:"
  print "<table>"
  print "  <tr>"
  print "    <td align=\"right\">files in DB:</td>"
  print "    <td align=\"right\">%s</td>" % (files)
  print "    <td></td>"
  print "  </tr><tr>"
  print "    <td align=\"right\">category&nbsp;entries:</td>"
  print "    <td align=\"right\">%s</td>" % (entries)
  print "    <td>(%.2f categories / file)</td>" % (float(entries) / files)
  print "  </tr><tr>"
  print "    <td align=\"right\">categories:</td>"
  print "    <td align=\"right\">%s</td>" % (cats)
  print "    <td>(%.2f entries / category)</td>" % (entries / float(cats))
  print "  </tr><tr>"
  print "    <td align=\"right\">total records:</td>"
  print "    <td align=\"right\">%s</td>" % (records)
  print "    <td>(%.2f records / file)</td>" % (float(records) / files)
  print "  </tr><tr>"
  print "    <td align=\"right\">space used:</td>"
  print "    <td align=\"right\">%s</td>" % (hsize)
  print "    <td>(%s / file)</td>" % (num_unit(int(float(bytes) / files)))
  print "  </tr>"
  print "</table>"

  
if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
