<?php
include_once("std.inc");
$title = "Photos";
$index = strrpos($path, "/");
$subtitle = "( " . substr($path, $index+1) . " )";
include_once("auth.inc");
include_once("counter.inc");
include("header.inc");

browse();

function browse()
{
  global $path;
  global $parts;
  global $photourl;
  global $photoroot;
  global $session;

  //print "Path: {$path}<br>\n";

  $allowed = auth_read("cat/{$path}", $session->user->name);
  if (! $allowed) { 
    print "Access denied.<br>\n"; 
    //login_form();
  }
  else {

    array_unshift($parts, "");
    $build = "";

    $df = dirfile("{$photoroot}/cat/{$path}");
    $df->read_mime();

    print "Viewing:\n";
    //foreach ($parts as $p)
    for($i=0; $i<sizeof($parts); $i++)
    {
      $p = $parts[$i];
      $slash = "/";
      // ignore empty parts, except for the first
      if ($build != ""  &&  $p == "") { continue; }
      if($build != "") { print " / \n"; }
      // avoid generating links to, say, "foo.jpg/"
      if(($i == sizeof($parts) - 1) && ($df->mimetype != "inode/directory"))
      {  $slash = "";  }
      $build = "{$build}{$p}{$slash}";
      if($p == "") { $p = "photos"; }
      print "<a href=\"{$photourl}{$build}\">{$p}</a>\n";
    }
    
    // TODO: incr on dl or med view for files, instead of here
    //       (would be more accurate)
    counter_incr("{$df->path}/.views");
    if (file_exists("{$df->path}/.views"))
    { 
      print "<small> &nbsp;&nbsp;&nbsp;&nbsp;( ";
      readfile("{$df->path}/.views");
      print " hit(s) ) </small>";
    }

    // Figure out what to do based on the mimetype...
    if($df->mimetype == "inode/directory")
    {
      show_dir($df, $path);
    }
    elseif(substr($df->mimetype, 0, 6) == "image/")
    {
      show_image($df, $path);
    }
    else
    {
      show_other($df, $path);
    }

  }
}

function show_dir($df, $path)
{
  global $photourl;
  global $photoroot;
  global $dir_browse_columns;
  global $HTTP_GET_VARS;
  global $session;

  show_desc($df);

  $amount = 12;
  if($HTTP_GET_VARS["amount"]) { $amount = $HTTP_GET_VARS["amount"]; }

  $first = 0;
  if($HTTP_GET_VARS["first"]) { $first = $HTTP_GET_VARS["first"]; }
  
  // Now show the item count
  print "<br>\n";
  $files = read_dir("cat/{$path}", $session->user->name);
  $end = $first + $amount;
  $num = sizeof($files);
  if($end > sizeof($files)) {$end = sizeof($files); }
  $a = $first + 1;
  print "Showing items {$a} - {$end} of {$num}<br>\n";
  $pagetext = "";
  $pagetext .= "<table width=\"100%\"><tr>\n";
  $navlink = "{$photourl}{$path}/";
  if($first > 0)
  {
    $prev = $first - $amount;
    if($prev < 0) {$prev = 0;}
    $pagetext .= "<td align=\"left\">\n";
    $pagetext .= "<a href=\"{$navlink}?first={$prev}&amount={$amount}\">Prev</a>\n";
    $pagetext .= "</td>\n";
  }
  if($end - $first < $num)
  {
    $pagetext .= "<td align=\"center\">\n";
    $pagetext .= "page: \n";
    $current_page = 1 + intval(floatval($first) / floatval($amount));
    $page = 1;
    for($a=0; $a<$num; $a+=$amount)
    {
      if ($page == $current_page) { $pagetext .= "[\n"; }
      $pagetext .= "<a href=\"{$navlink}?first={$a}&amount={$amount}\">{$page}</a>\n";
      if ($page == $current_page) { $pagetext .= "]\n"; }
      $page ++;
    }
    $pagetext .= "</td>\n";
  }
  if($end < $num)
  {
    $next = $first + $amount;
    if($next >= $num) {$next = $num-1;}
    $pagetext .= "<td align=\"right\">\n";
    $pagetext .= "<a href=\"{$navlink}?first={$next}&amount={$amount}\">Next</a>\n";
    $pagetext .= "</td>\n";
  }
  $pagetext .= "</tr></table>\n";
  print $pagetext;
  

  print "<hr noshade>\n";
  //print "<br>\n";
  
  if (sizeof($files) == 0) { print "Empty.<br>\n"; }
  else {

    // TODO: add a "/" to dirs if mimetype matches...
    $count = 0;
    $columns = $dir_browse_columns;
    $percent = sprintf("%d", 100.0 * 1.0 / $columns);
    print "<table border=0 width=\"100%\">\n";
    for($i=$first; $i<$end; $i++) {
      $f = $files[$i];

      $f->read_attrib(".description");
      $f->read_attrib(".views");
      $mime = $f->mimetype;

      $viewlink = "{$photourl}{$path}/{$f->basename}";
      $iconlink = "{$photourl}/_icon{$path}/{$f->basename}";
      $dllink = "{$photourl}/_dl{$path}/{$f->basename}";
      if($f->mimetype == "inode/directory") { $viewlink = "{$viewlink}/"; }
      if($f->mimetype == "inode/directory") { $dllink = $viewlink; }

      if(! file_exists("cat/{$path}/{$f->basename}/.icon"))
      {
	$iconlink = default_icon($f, $iconlink);
      }

      if($count % $columns == 0) { print "<tr>\n"; }
      print "<td width=\"{$percent}%\">\n";
      print "<div><center>\n";
      //print "<table border=0><tr><td>\n";
      print "<a href=\"{$viewlink}\"><img src=\"{$iconlink}\" border=\"0\"></a>\n";
      print "<br>\n";
      //print "</td></tr><tr><td>\n";
      print "<!-- {$f->mimetype}: --><a href=\"{$dllink}\">{$f->basename}</a>\n";

      $views = $f->attribs[".views"];
      if($views > 0) { print "<small>({$views})</small>\n"; }

      print "<br>\n";

      //print "</td></tr><tr><td>\n";
      $desc = $f->attribs[".description"];
      print "{$desc}<br>\n";
      print "</center></div><nobr>\n";
      //print "</td></tr></table>\n";
      print "</td>\n";
      if($count % $columns == ($columns - 1)) { print "</tr>\n"; }

      $count++;
    }
    if($count % $columns) { print "</tr>\n"; }
    print "</table>\n";
  }
  print "<hr noshade>\n";
  print $pagetext;

  print "<hr noshade>\n";
  show_desc_long($df);
}

function show_image($df, $path)
{
  global $photourl;
  global $photoroot;

  also_in($df, $path);
  show_desc($df);

  print "<hr noshade>\n";
  //print "show_image()<br>\n";

  $dllink = "{$photourl}/_dl{$path}";

  // Get medium-sized image info
  $imgtag = med_icon($df, $dllink, $path);
  if (file_exists("{$df->path}/.icon.med"))
  { print "<small>(click for larger image)</small><br>\n"; }

  //print "<a href=\"{$dllink}\"><img src=\"{$dllink}\" border=0 {$wh}></a>\n";
  print "<a href=\"{$dllink}\">{$imgtag}</a>\n";

  print "<hr noshade>\n";
  show_desc_long($df);
}

function show_other($df, $path)
{
  global $photourl;
  global $photoroot;

  $dllink = "{$photourl}/_dl{$path}";
  // TODO: return default icon if file doesn't exist
  $iconlink = "{$photourl}/_icon{$path}";

  also_in($df, $path);
  show_desc($df);

  print "<hr noshade>\n";
  //print "show_other()<br>\n";

  print "Cannot display file contents.  Why not \n";
  print "<a href=\"{$dllink}\">download</a>\n";
  print "the file and take a look?\n";

  print "<br>\n";
  print "<a href=\"{$dllink}\"><img src=\"{$iconlink}\" border=0></a>\n";

  print "<hr noshade>\n";
  show_desc_long($df);
}


function default_icon($f, $iconlink)
{
  global $photourl;

  $m = trim($f->mimetype);

  if ($m == "inode/directory")
  {
    return "{$photourl}/gfx/icons/folder.png";
  }
  elseif(substr($m, 0, 6) == "image/")
  {
    global $convert;
    global $thumb_wid;
    global $thumb_hgt;

    $wid = $thumb_wid;
    $hgt = $thumb_hgt;

    $realpath = "{$f->path}";
    //print "realfile: {$realpath}<br>\n";
    $info = getimagesize("{$realpath}/.data");
    if(! $info) { return $iconlink; }

    // No scaling necessary:
    if($info[0] <= $wid  &&  $info[1] <= $hgt)
    {
      // er, return a link to the original image...
      // TODO: return download link instead of icon link!
    }
    
    // TODO: handle animated gif properly (convert never stops)
    $cmd = "{$convert} '{$realpath}/.data' -geometry {$wid}x{$hgt} 'JPEG:{$realpath}/.icon'";
    //print "Running... {$cmd}<br>\n";
    $err = system($cmd);
    //print "Result: {$err}<br>\n";
    if (file_exists("{$realpath}/.icon")) {
      $fp = fopen("{$realpath}/.icon.mimetype", "w");
      fwrite($fp, "image/jpeg\n");
      fclose($fp);
    }
    else { print "Error generating thumbnail image.<br>\n"; }

    return $iconlink;
  }
  elseif(substr($m, 0, 6) == "video/")
  {
    return "{$photourl}/gfx/icons/video.png";
  }
  else
  {
    //print "{$m}<br>\n";
    return "{$photourl}/gfx/icons/other.png";
  }
}

function med_icon($df, $iconlink, $path)
{
  global $med_wid;
  global $med_hgt;
  global $convert;
  global $photourl;

  $medurl = "{$photourl}/_med{$path}";

  if (file_exists("{$df->path}/.icon.med"))
  {
    $info = getimagesize("{$df->path}/.icon.med");
    return "<img src=\"{$medurl}\" border=\"0\" {$info[3]}>";
  }
  
  // Get width/height
  $wh = "";
  $info = getimagesize("{$df->path}/.data");
  if (! $info)
  {
    return "<img src=\"{$iconlink}\" border=\"0\">";
  }
  else
  { 
    $wh = $info[3];
    $w = $info[0];  $h = $info[1];

    if ($w <= $med_wid  and  $h <= $med_hgt)
    {
      return "<img src=\"{$iconlink}\" border=0 {$wh}>";
    }

    $cmd = "{$convert} '{$df->path}/.data' -geometry {$med_wid}x{$med_hgt} 'JPEG:{$df->path}/.icon.med'";
    //print "Running... {$cmd}<br>\n";
    $err = system($cmd);
    //print "Result: {$err}<br>\n";
    if (file_exists("{$df->path}/.icon.med")) {
      $fp = fopen("{$df->path}/.icon.med.mimetype", "w");
      fwrite($fp, "image/jpeg\n");
      fclose($fp);

      $info = getimagesize("{$df->path}/.icon.med");
      return "<img src=\"{$medurl}\" border=\"0\" {$info[3]}>";
    }
    else { print "Error generating medium-sized image.<br>\n"; }
  }
  return "<img src=\"{$iconlink}\" border=0 {$wh}>";
}

function also_in($df, $path)
{
  // TODO: check permissions before displaying each other category
  global $photourl;
  $current_cat = substr($path, 0, strrpos($path, "/"));
  $catdir = "{$df->path}/.cats";
  $cats = get_dir_array($catdir);
  foreach ($cats as $c)
  {
    $ps = file("{$catdir}/{$c}", 0);
    $p = trim($ps[0]);
    //print "<br><br>{$p} == {$current_cat}?\n";
    if ($p != $current_cat)
    {
      $purl = "{$photourl}{$p}/";
      print "<br>(<small>also in... <a href=\"{$purl}\">{$p}</a></small>)\n";
    }
  }
}

function show_desc($df)
{
  // Show the description here
  $df->read_attrib(".description");
  if($df->attribs[".description"]) {
    print "<br>\n";
    print $df->attribs[".description"];
  }
}

function show_desc_long($df)
{
  // Show the description here
  $df->read_attrib(".description.long");
  if($df->attribs[".description.long"]) {
    print $df->attribs[".description.long"];
  }
}


include("footer.inc");
?>
